scala.tools.nsc.transform.patmat.MatchTreeMaking.TreeMakers

# TypeTestTreeMaker

###
Related Docs: object TypeTestTreeMaker | package TreeMakers

#### case class TypeTestTreeMaker(prevBinder: Global.Symbol, testedBinder: Global.Symbol, expectedTp: Global.Type, nextBinderTp: Global.Type)(pos: Global.Position, extractorArgTypeTest: Boolean = false) extends CondTreeMaker with Product with Serializable

implements the run-time aspects of (§8.2) (typedPattern has already done the necessary type transformations)

Type patterns consist of types, type variables, and wildcards. A type pattern T is of one of the following forms:

- A reference to a class C, p.C, or T#C. This type pattern matches any non-null instance of the given class. Note that the prefix of the class, if it is given, is relevant for determining class instances. For instance, the pattern p.C matches only instances of classes C which were created with the path p as prefix. The bottom types scala.Nothing and scala.Null cannot be used as type patterns, because they would match nothing in any case.
- A singleton type p.type. This type pattern matches only the value denoted by the path p (that is, a pattern match involved a comparison of the matched value with p using method eq in class AnyRef). // TODO: the actual pattern matcher uses ==, so that's what I'm using for now // https://issues.scala-lang.org/browse/SI-4577 "pattern matcher, still disappointing us at equality time"
- A compound type pattern T1 with ... with Tn where each Ti is a type pat- tern. This type pattern matches all values that are matched by each of the type patterns Ti.
- A parameterized type pattern T[a1,...,an], where the ai are type variable patterns or wildcards _. This type pattern matches all values which match T for some arbitrary instantiation of the type variables and wildcards. The bounds or alias type of these type variable are determined as described in (§8.3).
- A parameterized type pattern scala.Array[T1], where T1 is a type pattern. // TODO This type pattern matches any non-null instance of type scala.Array[U1], where U1 is a type matched by T1.

Source
  MatchTreeMaking.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, CondTreeMaker, FunTreeMaker, TreeMaker, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. TypeTestTreeMaker
2. Serializable
3. Serializable
4. Product
5. Equals
6. CondTreeMaker
7. FunTreeMaker
8. TreeMaker
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new TypeTestTreeMaker(prevBinder: Global.Symbol, testedBinder: Global.Symbol, expectedTp: Global.Type, nextBinderTp: Global.Type)(pos: Global.Position, extractorArgTypeTest: Boolean = false)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TypeTestTreeMaker to any2stringadd[TypeTestTreeMaker] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (TypeTestTreeMaker, B)

   Implicit information
     This member is added by an implicit conversion from TypeTestTreeMaker to ArrowAssoc[TypeTestTreeMaker] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def chainBefore(next: Global.Tree)(casegen: TreeMakers.Casegen): Global.Tree

   Definition Classes
     CondTreeMaker → TreeMaker

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @HotSpotIntrinsicCandidate() @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

9. #### val cond: Result

   Definition Classes
     TypeTestTreeMaker → CondTreeMaker

10. #### def ensuring(cond: (TypeTestTreeMaker) ⇒ Boolean, msg: ⇒ Any): TypeTestTreeMaker

    Implicit information
      This member is added by an implicit conversion from TypeTestTreeMaker to Ensuring[TypeTestTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (TypeTestTreeMaker) ⇒ Boolean): TypeTestTreeMaker

    Implicit information
      This member is added by an implicit conversion from TypeTestTreeMaker to Ensuring[TypeTestTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): TypeTestTreeMaker

    Implicit information
      This member is added by an implicit conversion from TypeTestTreeMaker to Ensuring[TypeTestTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): TypeTestTreeMaker

    Implicit information
      This member is added by an implicit conversion from TypeTestTreeMaker to Ensuring[TypeTestTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### val expectedTp: Global.Type

16. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from TypeTestTreeMaker to StringFormat[TypeTestTreeMaker] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

17. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

18. #### def impliesBinderNonNull(binder: Global.Symbol): Boolean

19. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

20. #### def isPureTypeTest: Result

21. #### lazy val localSubstitution: TreeMakers.Substitution

    Definition Classes
      CondTreeMaker → TreeMaker

22. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### lazy val nextBinder: Global.TermSymbol

    Definition Classes
      CondTreeMaker → FunTreeMaker

24. #### val nextBinderTp: Global.Type

    Definition Classes
      TypeTestTreeMaker → CondTreeMaker

25. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

26. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

27. #### lazy val outerTestNeeded: Boolean

28. #### val pos: Global.Position

    Definition Classes
      TypeTestTreeMaker → FunTreeMaker → TreeMaker

29. #### val prevBinder: Global.Symbol

    Definition Classes
      TypeTestTreeMaker → CondTreeMaker

30. #### def renderCondition(cs: TypeTestCondStrategy): Result

31. #### val res: Global.Tree

    Definition Classes
      TypeTestTreeMaker → CondTreeMaker

32. #### def subPatternsAsSubstitution: TreeMakers.Substitution

    The substitution that specifies the trees that compute the values of the subpattern binders.

    The substitution that specifies the trees that compute the values of the subpattern binders.

    Should not be used to perform actual substitution! Only used to reason symbolically about the values the subpattern binders are bound to. See TreeMakerToCond#updateSubstitution.

    Overridden in PreserveSubPatBinders to pretend it replaces the subpattern binders by subpattern refs (Even though we don't do so anymore -- see SI-5158, SI-5739 and SI-6070.)

    TODO: clean this up, would be nicer to have some higher-level way to compute the binders bound by this tree maker and the symbolic values that correspond to them

    Definition Classes
      TreeMaker

33. #### def substitution: TreeMakers.Substitution

    captures the scope and the value of the bindings in patterns important *when* the substitution happens (can't accumulate and do at once after the full matcher has been constructed)

    captures the scope and the value of the bindings in patterns important *when* the substitution happens (can't accumulate and do at once after the full matcher has been constructed)

    Definition Classes
      TreeMaker

34. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

35. #### val testedBinder: Global.Symbol

36. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      TypeTestTreeMaker → AnyRef → Any

37. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### def →[B](y: B): (TypeTestTreeMaker, B)

    Implicit information
      This member is added by an implicit conversion from TypeTestTreeMaker to ArrowAssoc[TypeTestTreeMaker] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from CondTreeMaker

### Inherited from FunTreeMaker

### Inherited from TreeMaker

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TypeTestTreeMaker to any2stringadd[TypeTestTreeMaker]

### Inherited by implicit conversion StringFormat from TypeTestTreeMaker to StringFormat[TypeTestTreeMaker]

### Inherited by implicit conversion Ensuring from TypeTestTreeMaker to Ensuring[TypeTestTreeMaker]

### Inherited by implicit conversion ArrowAssoc from TypeTestTreeMaker to ArrowAssoc[TypeTestTreeMaker]

### Ungrouped